class CreditCard {
  int cvv;
  int expMonth;
  int expYear;
  String number;
  CreditCard({this.cvv, this.expMonth, this.expYear, this.number});

  bool get isValid => _isValid();
  bool get isExpirationDateValid => _isExpirationDateValid();
  CreditCardBrand get brand => _getCCBrand();
  CreditCardBrand _getCCBrand() {
    Map<CreditCardBrand, RegExp> regexps = {
      CreditCardBrand.Visa: RegExp(r'^4[0-9]{12}'),
      CreditCardBrand.MasterCard: RegExp(r'^5[1-5]{14}$'),
      CreditCardBrand.AmericanExpress: RegExp(r'^3[47][0-9]{13}$'),
      CreditCardBrand.DinersClub: RegExp(r'^3.*'),
    };
    for (MapEntry<CreditCardBrand, RegExp> regex in regexps.entries) {
      if (regex.value.hasMatch(this.number)) {
        return regex.key;
      }
    }
    return CreditCardBrand.None;
  }

  bool _isValid() {
    this.number = this.number.trim();
    if (int.tryParse(this.number) == null) {
      return false;
    }
    int sum = 0;
    int pivot = this.number.length % 2;
    for (int i = this.number.length - 1; i >= 0; i--) {
      int d = int.parse(number[i]);
      if (i % 2 == pivot) {
        d = d * 2;
      }
      if (d > 9) {
        d = d - 9;
      }
      sum = sum + d;
    }
    if (sum % 10 == 0) {
      return true;
    } else {
      return false;
    }
  }

  bool _isExpirationDateValid() {
    DateTime date = DateTime.now();
    if (this.expMonth > 12) {
      return false;
    }
    //TODO: Actualizar la fecha de expiracion en el anio 2090
    if (this.expYear > 99 && this.expYear < 2000) {
      return false;
    }

    if (this.expYear < 99) {
      this.expYear = 2000 + this.expYear;
    }
    if (date.year < this.expYear) {
      return true;
    }

    if (date.year == this.expYear) {
      if (date.month <= this.expMonth) {
        return true;
      }
    }

    return false;
  }
}

enum CreditCardBrand {
  Visa,
  MasterCard,
  AmericanExpress,
  DinersClub,
  None,
}
