import 'dart:convert';

import 'package:http/http.dart' as http;
import 'package:http/http.dart';
import 'package:payment_processors/culqi_exception.dart';

import 'culqi_token_response.dart';

class CulqiRequest {
  static const CULQI_TOKEN_URL = "https://secure.culqi.com/v2/tokens";
  static Future<CulqiTokenResponse> getCulqiToken(
      String token, http.Client client, Map<String, dynamic> body) async {
    Map<String, String> headers = {
      "Content-Type": "application/json",
      "Authorization": "Bearer $token"
    };
    Response response = await client.post(CULQI_TOKEN_URL,
        headers: headers, body: json.encode(body));
    if (response.statusCode == 201) {
      return CulqiTokenResponse.fromJson(jsonDecode(response.body));
    } else {
      throw CulqiException(message: "No es 200");
    }
  }
}
