import 'package:payment_processors/credit_card.dart';
import 'package:test/test.dart';

void main() {
  group('ValidCC', () {
    test('checks that credit card value is valid', () {
      CreditCard cc = CreditCard(
        number: "4111111111111111",
      );
      expect(cc.isValid, true);
    });
    test('checks that credit card value is valid', () {
      CreditCard cc = CreditCard(
        number: "371212121212122",
      );
      expect(cc.isValid, true);
    });
  });

  group('InvalidCC', () {
    test('checks that credit card value is valid', () {
      CreditCard cc = CreditCard(
        number: "4111111111111112",
      );
      expect(cc.isValid, false);
    });
    test('checks that credit card value is valid', () {
      CreditCard cc = CreditCard(
        number: "abcdef",
      );
      expect(cc.isValid, false);
    });
    test('checks that credit card value is valid', () {
      CreditCard cc = CreditCard(
        number: "123",
      );
      expect(cc.isValid, false);
    });
  });
  group('ValidExpirationDate', () {
    test('checks that credit card expiration date is valid', () {
      CreditCard cc = CreditCard(
        cvv: 123,
        expYear: 2020,
        expMonth: 7,
      );
      expect(cc.isExpirationDateValid, true);
    });

    test('checks that credit card expiration date is valid', () {
      CreditCard cc = CreditCard(
        cvv: 123,
        expYear: 2020,
        expMonth: 8,
      );
      expect(cc.isExpirationDateValid, true);
    });
    test('checks that credit card expiration date is valid', () {
      CreditCard cc = CreditCard(
        cvv: 123,
        expYear: 20,
        expMonth: 8,
      );
      expect(cc.isExpirationDateValid, true);
    });
  });

  group('InvalidExpirationDate', () {
    test('checks that credit card expiration date is invalid', () {
      CreditCard cc = CreditCard(
        cvv: 123,
        expMonth: 12,
        expYear: 2015,
      );
      expect(cc.isExpirationDateValid, false);
    });
    test('checks that credit card expiration date is invalid', () {
      CreditCard cc = CreditCard(
        cvv: 123,
        expYear: 2020,
        expMonth: 6,
      );
      expect(cc.isExpirationDateValid, false);
    });
    test('checks that credit card expiration date is invalid', () {
      CreditCard cc = CreditCard(
        cvv: 123,
        expMonth: 13,
        expYear: 2015,
      );
      expect(cc.isExpirationDateValid, false);
    });
  });

  group('CCBrand', () {
    test('Visa Brand', () {
      CreditCard cc = CreditCard(
        number: "4111111111111111",
      );
      expect(cc.brand, CreditCardBrand.Visa);
    });
    test('MC Brand', () {
      CreditCard cc = CreditCard(
        number: "371212121212122",
      );
      expect(cc.brand, CreditCardBrand.AmericanExpress);
    });
    test('No Brand', () {
      CreditCard cc = CreditCard(
        number: "971212121212122",
      );
      expect(cc.brand, CreditCardBrand.None);
    });
  });
}
