import 'dart:convert';
import 'dart:io';

import 'package:payment_processors/culqi_exception.dart';
import 'package:payment_processors/culqi_token_response.dart';
import 'package:test/test.dart';

void main() {
  CulqiTokenResponse response;
  Map<String, dynamic> decodedJson;
  Map<String, dynamic> invalidYearDecodedJson;

  //TODO: Make this work regardless of OS
  setUp(() async {
    File file = File('test\\fixtures\\token_generation_ok.json');
    decodedJson = jsonDecode(await file.readAsString());

    File invalidDateFile =
        File('test\\fixtures\\token_generation_invalid_year.json');
    invalidYearDecodedJson = jsonDecode(await invalidDateFile.readAsString());
  });

  test('Validate incoming response', () {
    response = CulqiTokenResponse.fromJson(decodedJson);
    expect(response.id, "tkn_test_1nO1bpPbq10h3GT9");
    expect(response.object, "token");
    expect(response.cardNumber, "411111******1111");
    expect(response.email, "richard@piedpiper.com");
  });

  test('Validate invalid request', () {
    expect(() => CulqiTokenResponse.fromJson(invalidYearDecodedJson),
        throwsA(TypeMatcher<CulqiException>()));
  });
}
